
//Activar el dump de chrome en el terminal
// browser.dom.window.dump.enabled --> true



esvytimeout       = null;
esvyinfopage      = '';
verificationpage  = '';
noHash            = false;
esvylastmsg       = '';
esvyisffx2        = false;
surveyBrowser     = null;
esurveycomp       = null;
eSurveyObj        = null;
params            = '';
paramsSig         = '';
LenToUse          = 0;
storePersonalData = false;

function showpage(){

  //Este muestra la pgina del tab que est seleccionado actualmente
  //dump(window.gBrowser.selectedBrowser.contentWindow.document.documentElement.innerHTML+"------------------------------\n");

  //Este muestra la pgina del tab que haba seleccionado cuando se inicializ el componente (supuestamente el que contiene la encuesta)
  //dump(surveyBrowser.contentWindow.document.documentElement.innerHTML+"------------------------------\n");
}



function switchWidgets(){
  
  
  //ocultamos el selector de anonimato.
  document.getElementById('anonimLevel').setAttribute('hidden', 'true');  
  
  
  //Si hay verificacion, mostramos el cuadro de hash
  if(!noHash){
    document.getElementById('thascontainer').setAttribute('hidden', 'false');  //Mostrar cuadro de hash
  }
  
  
  
}


function setAnonimity (){


  //Establecemos el nivel de anonimato a usar
  var minRouLen  = document.getElementById('anonimSelector').selectedItem.value;
  ////dump("minRouLen (prefs): "+minRouLen+"\n"); 
  
  //Las longitudes especiales para directo a urna son:
  // -2: Sin RLC y sin firma ciega (funciona)
  // -1: ? (no funciona)
  //  0: Sin RLC pero con firma ciega (no funciona, y eSurvey.js da el mensaje mal, dice que no lleva firma ciega)

  //alert(minRouLen);
  
  LenToUse = minRouLen;
  ////dump("LenToUse (previo): "+LenToUse+"\n"); 

  
//  if(eSurveyObj != null)
//    eSurveyObj.XXX = minRouLen;
//    eSurveyObj.XXX(minRouLen);


}



function eSurveyCheckFrames(subwin){
  
  var svys = 0;
  var params = null;
  
  
  try{
    //Verificamos si este frame tiene eSurveys
    var page = subwin.document.documentElement.innerHTML;
    
    ////dump("------------Page------------\n"+page+"\n");
    
    params=page.replace(/\n/g,'').match(/<eSurveyParameters>.*?<\/eSurveyParameters>/);
    
    // //dump("------------Params------------\n"+params+"\n");
 


    if(params != null && params != ''){
      svys++;
      ////dump('Hay un eSurvey\n');
    }
  
    // //window.frames[0].frames =0;
    //window.frames[0].document.documentElement.innerHTML
    //subwin.document.documentElement.innerHTML
    //Ahora slo cuenta los frames, poner aqu luego el cdigo para ver si hay un esurvey

  
  
  
    ////dump("Es frame hoja? ");
  
    if( subwin.frames == 'undefined' || subwin.frames.length <= 0){  //Es nodo hoja
    
      ////dump("Si. : "+subwin.frames+"\n");
      return svys;    
    }    
  
    ////dump("No.\n");
  

    for(var fr=0; fr < subwin.frames.length; fr++){
    
      ////dump("Recorriendo frame "+fr+"\n");
    
      svys += eSurveyCheckFrames(subwin.frames[fr]);
    
    }
    
  }catch(e){
    //dump("--->error checking frames");
  }
  
  return svys;
}



function eSurveyOpenSurveys(chromewin){

  var svys = 0;
  
  //Para cada tab abierto
  for(var tab=0; tab<chromewin.gBrowser.browsers.length; tab++){  //Recorre objetos de tipo browser
    
    var currtab = chromewin.gBrowser.getBrowserAtIndex(tab);
    
    ////dump("Viendo tab "+tab+"\n");
    
    //Le pasamos una ref al domwindow
    //svys += eSurveyCheckFrames(currtab.contentDocument.defaultView.window);
    svys += eSurveyCheckFrames(currtab.contentWindow);
    
  }
  
  ////dump("Num de eSurveys abiertos: "+svys+"\n");
  
  ////dump("----------------------------------------\n");
  
  return svys;
}






function eSurveyFindParams(subwin,re){
    
  var params = '';
  
  
  try{
    var page = subwin.document.documentElement.innerHTML;
  
    params=page.replace(/\n/g,'').match(re);
  
    //Si ha encontrado los params, vuelve
    if(params != ''&& params != null){
      return params;
    }
  
    //Si no los ha encontrado y es hoja, vuelve con cad vacia
    if( subwin.frames == 'undefined' || subwin.frames.length <= 0){
      return '';    
    }    
  
    //Comprobamos los subarboles de este nodo y si alguno tiene los params, los propagamos hacia arriba
    for(var fr=0; fr < subwin.frames.length; fr++){
      params = eSurveyFindParams(subwin.frames[fr]);
    
      if(params != ''&& params != null)
	break;
    }
  }catch(e){
    //dump("Error finding params\n");
  }
  
  return params;
}



function getParamString(re)
{

    var params = '';
    
    if(eSurveyOpenSurveys(window)>1){
        return '';
    }
    
    
    //Para cada tab abierto
    for(var tab=0; tab<window.gBrowser.browsers.length; tab++){
        
        var currtab = window.gBrowser.getBrowserAtIndex(tab);
        
        ////dump('tab '+tab+'\n');
        
        params = eSurveyFindParams(currtab.contentWindow,re);
        
        if(params != '' && params != null){
            break;
        }
    }

    ////dump("-----------Params------------------\n"+params+"\n");

    return params;

};







function eSurveyFoundSurvey(subwin){
  
  var params = '';
  var found = false;
  
  try{
    var page = subwin.document.documentElement.innerHTML;
  
    params=page.replace(/\n/g,'').match(/<eSurveyParameters>.*?<\/eSurveyParameters>/);
  
  
    //Si ha encontrado los params, es este tab
    if(params != ''&& params != null){
      return true;
    }
  
    //Si no los ha encontrado y es hoja, de momento no es este tab
    if( subwin.frames == 'undefined' || subwin.frames.length <= 0){
      return false;    
    }    
  
    //Comprobamos los subarboles de este nodo y si alguno tiene los params, los propagamos hacia arriba
    for(var fr=0; fr < subwin.frames.length; fr++){
      found = eSurveyFoundSurvey(subwin.frames[fr]);
    
      if(found)
	break;
    }
  }catch(e){
    //dump("Error finding survey\n");
  }
  
  return found;
}




function getSurveyBrowser(){
  
  var tab = 0;

  if(eSurveyOpenSurveys(window)>1){
    return null;
  }
  
  //Para cada tab abierto
  for(tab=0; tab<window.gBrowser.browsers.length; tab++){
    
    var currtab = window.gBrowser.getBrowserAtIndex(tab);
    
    ////dump('tab '+tab+'\n');
    
    if(eSurveyFoundSurvey(currtab.contentWindow)){
      break;
    }
  }
  
  ////dump('Estaba en el tab: '+tab+'\n');
  return window.gBrowser.getBrowserAtIndex(tab);
}







 function eSurveyFindDomWindow(subwin){
    
   var params = '';
  
   try{
     var page = subwin.document.documentElement.innerHTML;
  
     params=page.replace(/\n/g,'').match(/<eSurveyParameters>.*?<\/eSurveyParameters>/);
  
     if(params != ''&& params != null){
       return subwin;
     }
  
     //Si no los ha encontrado y es hoja, vuelve con cad vacia
     if( subwin.frames == 'undefined' || subwin.frames.length <= 0){
       return null;    
     }    
  
     //Comprobamos los subarboles de este nodo y si alguno tiene los params, los propagamos hacia arriba
     for(var fr=0; fr < subwin.frames.length; fr++){
       var win = eSurveyFindDomWindow(subwin.frames[fr]);
    
       if(win != null)
	 return win;
     }
  
   }catch(e){
     //dump("Error getting domwindow\n");
   }
   return null;
 }


function eSurveyGetDomWindow(subwin){
    
  var tab = 0;

  var win = null;

  if(eSurveyOpenSurveys(window)>1){
    return null;
  }
  
  //Para cada tab abierto
  for(tab=0; tab<window.gBrowser.browsers.length; tab++){
    
    var currtab = window.gBrowser.getBrowserAtIndex(tab);
    
    ////dump('tab '+tab+'\n');
    
    win = eSurveyFindDomWindow(currtab.contentWindow);

    if(win != null){
      return win;
    }
  }
  
  return null;
}




function notify(msg){

  var ttp  = document.getElementById('esvynotiftooltip');
  var desc = document.getElementById('esvynotifier');
  var win  = document.getElementById('main-window');
  var hook = document.getElementById('tlog');

  if ( ttp==null || desc==null || win==null )
	return true

  desc.textContent = msg;

  if(ttp.openPopup && ttp.hidePopup){ //FFX3
   // ttp.openPopup(null,'',window.screen.width/2-150,40,false,true);
    //300 es la anchura del ttp. No puedo averiguarla, as que la establezco por CSS
    ttp.openPopup(hook,'overlap',hook.clientWidth-300,0,false,true);

    if(esvytimeout != null)
      clearTimeout(esvytimeout);

    esvytimeout = setTimeout("var kk = document.getElementById('esvynotiftooltip'); if (kk) kk.hidePopup();",10000);

  }else{ 
     //alert('settingstatus');
     document.getElementById('content').contentDocument.defaultView.window.status = msg;
  }
}





function preInit(){

  ////dump('------------------------------------------>Llamada a preInit.\n');


  ////dump("Window: "+window.innerWidth+"\n");



  surveyBrowser = getSurveyBrowser();

  //surveyBrowser = window.gBrowser.selectedBrowser;    //global
    
  //surveyTab = window.gBrowser.selectedTab;            //global  //Ya no la uso
  


  esurveycomp =  Components.classes['@uji.es/eSurvey;1'].createInstance();
  ticketpopupshown = false;

  eSvyStringsBundle = esurvey_get_stringbundle();

  var logopreload = document.createElement('img');
  logopreload.src = "chrome://esurvey/content/eSurveyLargeBlink.png';imgTTPshow();";

  
  //document.getElementById('esurveymenuitem').label = eSvyStringsBundle.GetStringFromName('menu.unload');
  document.getElementById('esurveymenuitem').setAttribute("disabled", "true");
  

  //Disable Javascript y otros
  //--------------------------

  // Detiene la carga, refresco o cualquier navegacion de la pagina
  surveyBrowser.webNavigation.stop(surveyBrowser.webNavigation.STOP_ALL);

  // Evita la ejecucion de los plugins necesarios en el doc asociado 
  surveyBrowser.docShell.allowPlugins = false;

  // Evita la ejecucion del javascript existente en el doc asociado 
  surveyBrowser.docShell.allowJavascript = false;

  //Evita que salgan prompts de autenticacion ssl 
  surveyBrowser.docShell.allowAuth = false;


  //No vale porque se ejecuta tras el cierre de la pgina.
  document.getElementById('content').contentDocument.defaultView.window.addEventListener('unload', unload_handler, 0);



/*
  //surveyBrowser.contentDocument.defaultView.window.addEventListener('beforeunload', unloadMess, 0);


  //surveyBrowser.contentDocument.defaultView.window.onbeforeunload = unloadMess;

  surveyBrowser.contentDocument.defaultView.window.onbeforeunload = unloadMess;

function unloadMess(){

//dump("--->"+surveyBrowser.contentDocument.defaultView.documentView.window+"\n");

surveyBrowser.contentDocument.stop();

mess = "Cerrar sesion"
return mess;
//alert("ahora voy y lo paro")
//surveyBrowser.webNavigation.stop(surveyBrowser.webNavigation.STOP_ALL); 
//return true;
}


//++++++++++++++++++++++++++
function test () {

return confirm('segurasdxasdasdaso que desea apagar?')
//if ( confirm('seguro que desea apagar?') == false)
  //surveyBrowser.webNavigation.stop(surveyBrowser.webNavigation.STOP_ALL); 

}
*/
  
  

  //Ocultamos el cuadro del hash
  document.getElementById('thascontainer').setAttribute('hidden', 'true');  



  
  //PARAMS DE LA ENCUESTA
  
  //Intenta leer los params del componente, por si el lanzador se los ha pasado
  params=esurveycomp.getParams();
  
  //dump("\n-----------Params leidos del componente------------\n"+params+"\n-----------------------\n");
  
  //Sino, los busca en todas las ventanas
  if(params == ''){
    ////dump("Buscando params.\n");
    var paramRE = /<eSurveyParameters>.*?<\/eSurveyParameters>/;
    params=''+getParamString(paramRE);
    //dump("\n-----------Params encontrados------------\n"+params+"\n-----------------------\n");
  }

  ////dump("obtenidos parametros\n");
  
  ////dump("---------------------------------------\n"+params+"---------------------------------------\n")


  paramsSig=esurveycomp.getParamsSig();

  //dump("------------------Por params---------------------\n"+paramsSig+"---------------------------------------\n");
  
  if(paramsSig == '' || paramsSig == null){
    //dump("Buscando params por regexp.\n");
    var paramSigRE = /<eSurveyPrsSignature>.*?<\/eSurveyPrsSignature>/;
    paramsSig=''+getParamString(paramSigRE);  
    
    //dump("------------------Por la pag---------------------\n"+paramsSig+"---------------------------------------\n");
    
  }
  
  if(params && params != ''){  //Hay una encuesta valida

    var maxEligibleLen = 7;

/*  De momento NO HACERLO  // ////
    // Definimos el tamao mximo de ruta eligible segn la fecha de
    // cierre (si est definida), pues el margen podra no ser
    // suficiente si se ha manipulado a mano y no siguiendo el
    // algoritmo que emplea eSurvey para determinarlo.
    try{

      //Obtenemos las fechas de fin y cierre de la eleccin
      var endDRE = /<endD>([0-9]+)<\/endD>/g;
      var endD   = endDRE.exec(params)[1];
      
      var cloDRE = /<cloD>([0-9]+)<\/cloD>/g;
      var cloD   = cloDRE.exec(params)[1];
      
      //dump("-----> endD (str): "+endD+"\n");
      //dump("-----> cloD (str): "+cloD+"\n");



//      //dump("-----> getTime: "+(new Date(endD)).getTime()+"\n");      

//            endD=parseInt(Math.floor(/1000));

      
      endD=Math.floor((new Date(parseInt(endD)/1000)).getTime());
      cloD=Math.floor((new Date(parseInt(cloD)/1000)).getTime());
      
      //dump("-----> endD: "+endD+"\n");
      //dump("-----> cloD: "+cloD+"\n");

      if (isNaN(endD) || isNaN(cloD))
	throw('Bad cloD or endD');

      // Si cloD es 0, ponemos la mxima, porque ya se apaa
      // eSurvey.js para calcularlo y tratarlo y soporta una ruta de
      // 7.
      if (cloD == 0)
	throw('Use the max');
      
      
      var sfy=600, tolPerJump=120;  // **** extraidas de eSurvey.js
      
      //Calculamos la cloD mnima para cada tamao de ruta desde el mayor posible hasta 0
      for(var rl=7;rl>=0; rl--){
	
	//Si la cloD llega al punto de no admitir LCN
	if(rl == 0){
	  
	  //aviso de que no hay anonimato (panel y alert?) // ////
	  alert('Nos obliga a no usar anonimato, jarl!!!!');
	  
	  
	  //sacar slo la directa a la urna
	  var maxEligibleLen = 0;	  
	  break;
	}

	//Calculamos la tolerancia para esta longitud de ruta
	var tol=tolPerJump*rl;
	
	var thisCloD=endD+2*(sfy+tol);   //Calcula la cloD mnima para esa ruta

	// Si la cloD mnima para esta long de ruta entra dentro de la
	// cloD estipulada por el servidor, es la long de ruta mxima
	// admisible.
	if (thisCloD <= cloD) {
	  var maxEligibleLen = rl;
	  break;
	}
	
      }
      
    }
    catch(e){
      //Si hay algn error, usar la configuracin estndar
      
      //dump("---> "+e+"\n");

      var maxEligibleLen = 7;
    }


    //Si es necesario, ocultamos niveles de anonimato // ////
    for(var rl=7;rl>maxEligibleLen; rl--){
      document.getElementById('anlv'+rl).disabled = true;
    }


*/

    //Obtener el valor ms seguro de anonimato entre el almacenado en las prefs y el establecido por el servidor
    //Este ser el valor por defecto
    var forcedMinRoute = 0;
    try{
      // Get the root branch
      // var prefs = Components.classes["@mozilla.org/preferences-service;1"]
      //                        .getService(Components.interfaces.nsIPrefBranch);
      
      var prefs = Components.classes["@mozilla.org/preferences-service;1"]
	.getService(Components.interfaces.nsIPrefService);
      prefs = prefs.getBranch("extensions.eSurvey@uji.");
      
      //Notar que si alguien la cambia a mano, esta prevalecer aunque se desisntale la extension
      forcedMinRoute = prefs.getIntPref("forceMinimumRouteLength");

      var rouLenRE = /<rouLen>([0-9]+)<\/rouLen>/g;
      
      var rouLen = rouLenRE.exec(params)[1];

      ////dump("rouLen (RE): "+rouLen+"\n"); 

      LenToUse = Math.max(forcedMinRoute,rouLen);

      ////dump("LenToUse (definitiva): "+LenToUse+"\n"); 

      //Slo defino maxEligibleLen niveles de anonimato
      if(LenToUse > maxEligibleLen)
	LenToUse = maxEligibleLen;

    }
    catch(e){
      //alert("Error "+e+" obteniendo la preferencia");
      LenToUse = 3;
      ////dump("LenToUse (catch): "+LenToUse+"\n"); 
    }




    // ////
    
    //Obtenemos la preferencia que nos dice si debemos almacenar el hash y el pwd de recovery o no (por ejemplo, si es un ordenador compartido).

    try{
      var prefs = Components.classes["@mozilla.org/preferences-service;1"]
	.getService(Components.interfaces.nsIPrefService);
      prefs = prefs.getBranch("extensions.eSurvey@uji.");
      
      storePersonalData = prefs.getBoolPref("storePersonalData");
    }   
    catch(e){
      storePersonalData = false;
    }



    //alert(" rouLen: "+rouLen);
    //alert("enc.minRouLen: "+enc.minRouLen+" forcedMinRoute: "+forcedMinRoute);
    
    
    //Preseleccionamos el nivel de anonimato sugerido en el selector
    document.getElementById('anonimSelector').selectedIndex = LenToUse;


    //Invitamos al usuario a elegir el nivel de anonimato que desea emplear.
    notify(eSvyStringsBundle.GetStringFromName('selectanonim'));
    
    

    //Cambiar etiqueta
    document.getElementById('but').setAttribute('value',eSvyStringsBundle.GetStringFromName('startVoting'));

    //Cambiar handler del botn    
    document.getElementById('but').setAttribute('onclick','inicializar();');




    
  }//if (params)
  else{
    notify(eSvyStringsBundle.GetStringFromName('nosurveys'));
  }
  

}



function inicializar(){
  
  ////dump('------------------------------------------>Llamada a inicializar.\n');

  //ocultamos el selector de anonimato porque ya no podr operarse. 

  //document.getElementById('but').removeEventListener('command', inicializar, 0); 


  document.getElementById('but').setAttribute('onclick','switchWidgets();enc.send();');

  document.getElementById('but').setAttribute('value','wait...');

  document.getElementById('anonimLevel').setAttribute('hidden', 'true'); 

  
  



  //Notificar instrucciones
  notify(eSvyStringsBundle.GetStringFromName('initialinstructions'));

  var borr = document.getElementById('esvynotiftooltip');
  if(!borr.hidePopup){
    esvyisffx2 = true;
    borr.setAttribute('hidden','true');
  }


  //Instanciar eSurvey
  //------------------

  if(params && params != ''){  //Hay una encuesta valida


   

    ////dump('--------------->Chrome: Instantiating esurvey\n');
    enc=new eSurvey(params,paramsSig);
    
    //Establecemos el nivel de anonimato a usar (preseleccionado arriba por el usuario)
    enc.minRouLen = LenToUse;
    ////dump("*********** using length: "+enc.minRouLen);
    

    enc.guarda = storePersonalData;
    

    //Lo guardamos en var global
    eSurveyObj = enc;

    //Sobrecargamos el elemento forms
    //No podra darse el caso de que se ejecutase antes el trozo donde busca el formulario que este donde lo definimos? ******** 
    enc.forms = eSurveyGetDomWindow(window).document.forms;
    
    enc.but=document.getElementById('but');
    enc.tlog=document.getElementById('tlog');
    enc.thash=document.getElementById('thas');
    enc.oldChStage=enc.chStage;


    // !!!!!!!! podra ser la variable glo_... de esurvey?, que sea la misma y se sobreescriba? imprimir su valor



    //Sobrecargamos la func de muestra del ticket para que salga solo el hash
    enc.showHash= function (h) {
      if (this.thash)
        this.thash.value=h;
      else {
        this.log(h);
        if (urnIExp)
	  alert(h);
      }
    }

    esvyinfopage = enc.urlExt;

    verificationpage = enc.urlVer;


    if(typeof verificationpage == undefined || verificationpage ==''|| verificationpage == null)
       noHash = true;

    //El cuadro de hash empieza siempre oculto, y se muestra cuando se oculta el selector de anonimato, al pulsar el botn.
    document.getElementById('thascontainer').setAttribute('hidden', 'true');  //Ocultar cuadro


 


    //Sobrecargamos el cambio de estado de eSurvey para que haga cosas que queremos en el chrome
    enc.chStage= function (st) {
      this.oldChStage(st);
      
      if (st == 'snok'){
 
       //Esta activa la barra y se ha enviado
	////dump('--------------->Chrome inside esurvey inside Chrome: Setting state 2\n');
	// !!!!!!  y si el problema es que estoy accediendo a vars globales dentro de esta funcin que est enlazada en el objeto esurvey?. podra darse el caso de que al acceder a variables globales de este mbito, eso se mezclase con ... parece una chorrada...
       esurveycomp.setState(2);

       if(this.refresh){
	 var not = '';
       }else{
	 var not = eSvyStringsBundle.GetStringFromName('closeString');
       }
       

       if(!noHash){  //Si se muestra el hash

	 //El mensaje dice tb que debe hacer con el.
         not+=' \n'+eSvyStringsBundle.GetStringFromName('getticketString');
	 
	 //Adems, sacamos la URL de verificacin en el Log por si alguien se apunta el cdigo a mano sin imprimirlo ni copiarlo (es decir, sin ver el men contextual)
	 this.log(eSvyStringsBundle.GetStringFromName('verifyticketString')+" "+verificationpage);
       }


       //Si hay refresh y no hay hash, no saca nada. Si hay refresh y hash saca slo el mensaje del hash
       if(not != '')
	 notify(not);
       
       
       
       //Si conviene a la aplicacin de voto/encuesta que est usando, el botn de enviar pasar a tener el comportamiento de recargar la pgina. Para facilitar al votante continuar usando la aplicacin.
       //Se condiciona porque no todas las personalizaciones de eSurvey esperan un reload tras acabar de votar y el resultado puede ser confuso para el votante.
       if(this.refresh){

	 //Reactivamos el botn
	 this.but.disabled=false;

	 //Cambiar comportamiento
	 //this.but.setAttribute('onclick','eSurveyGetDomWindow(window).location.reload();');
	 var loc = eSurveyGetDomWindow(window).location;
	 var exitUrl = loc.protocol+'//'+loc.hostname+':'+loc.port+loc.pathname;
	 //dump("\n----"+exitUrl+"----\n");
	 this.but.setAttribute('onclick','eSurveyGetDomWindow(window).location.assign(\''+exitUrl+'\');');

       }

       //alert('setting state 2');
       //setTimeout('cerrarBarra()',5000);

      }


       if (st == 'crit'){
 
       
       notify(eSvyStringsBundle.GetStringFromName('critical'));

      }

    if (st == '1snd'){
 
       
	TTPhide('esvynotiftooltip');

	TTPhide('esvysendtooltip');

 	 if(!noHash && !ticketpopupshown) {
		ticketpopupshown =  true;
        	 notify(eSvyStringsBundle.GetStringFromName('getticketString1'));
         }

      }


      

    }







  }//if (params)
  else{
    notify(eSvyStringsBundle.GetStringFromName('nosurveys'));
  }
  
  
  
  
  
  
}




function esurvey_get_stringbundle()
{
    var o_stringbundle = false;

    try {
        var oBundle = Components.classes["@mozilla.org/intl/stringbundle;1"]
                                .getService(Components.interfaces.nsIStringBundleService);
        o_stringbundle = oBundle.createBundle("chrome://esurvey/locale/esurvey.properties");
    } catch(err) {
        o_stringbundle = false;
    }
    if (!o_stringbundle) {
        //error
    }

    return o_stringbundle;
}





function loadInfoPage(){


   if(typeof esvyinfopage == undefined || esvyinfopage == null)
     esvyinfopage = 'http://esurvey.nisu.org';  //Esta por defecto

  document.getElementById('content').contentDocument.defaultView.window.open(esvyinfopage);


}


function loadHashPage(){
  
  //document.getElementById('content').contentDocument.defaultView.


  var hash = document.getElementById('thas').value;
  
  if ( hash==null)
    return true;
      


  var hashw = window.openDialog('chrome://esurvey/locale/ticketStub.html','eSuvyHashVerifWin','width=1024,height=768,location',{'hashVal':hash,'hashUrl':verificationpage});
  
      
      
  //var hashdiv  = hashw.document.getElementById('esurveyticketdiv');
  //var verifdiv = hashw.document.getElementById('esurveyverificationurl');
  
 //   var hashdiv = hashw.contentDocument.defaultView.window.document.getElementById('esurveyticketdiv');
 //   var verifdiv = hashw.contentDocument.defaultView.window.document.getElementById('esurveyverificationurl');
  
  //Escribimos el hash en la plantilla.
//  hashdiv.innerHTML = hash;
  
//  verifdiv.innerHTML = verificationpage;
  
}


function openHashMenu(){


 var menu = document.getElementById('esurveyticket-menu');
  var bt  = document.getElementById('thas');

 if ( menu==null || bt==null )
	return true

  if(menu.openPopup){ //FFX3
    menu.openPopup(bt,'after_pointer',2,2,false,false);
  }else if(menu.showPopup){
    menu.showPopup(bt,-1,-1,'context','bottomleft','topleft');
  }
  else{
    //alert('Esto no debería pasar');
  }


}


function PrintHash(){

  //alert('imprimiendo');

  var hash = document.getElementById('thas').value;

  var hashf = document.getElementById('hashframe');

  if ( hash==null || hashf==null )
    return true;
  
  
  var hashdiv = hashf.contentDocument.defaultView.window.document.getElementById('esurveyticketdiv');
  var verifdiv = hashf.contentDocument.defaultView.window.document.getElementById('esurveyverificationurl');
 
  //Escribimos el hash en la plantilla.
  hashdiv.innerHTML = hash;
  
  verifdiv.innerHTML = verificationpage;

  hashf.contentDocument.defaultView.window.print();

}


function CopyHash(){

  var hash = document.getElementById('thas').value;

  //alert(hash);

  const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper); 

  gClipboardHelper.copyString(hash);


}




function imgTTPshow(){

  var ttp = document.getElementById('esvyimgtooltip');
  var bt  = document.getElementById('logo');

 if ( ttp==null || bt==null )
	return true

  if(ttp.openPopup){ //FFX3
    ttp.openPopup(bt,'after_pointer',95,95,false,false);
  }else if(ttp.showPopup){
    //ttp.showPopup(bt,-1,-1,'tooltip','topleft','topleft');

    var cadena = eSvyStringsBundle.GetStringFromName('infopage');
    
    var statusstr = document.getElementById('content').contentDocument.defaultView.window.status;
  
    if(statusstr!=cadena)
      esvylastmsg = statusstr;  //Para pdoer recuperar el mensaje anterior aunque pasemos el cursor varias veces

    document.getElementById('content').contentDocument.defaultView.window.status = cadena;
  
  }
  else{
    //alert('Esto no debería pasar');
  }
}



function sendTTPshow(){

  var ttp = document.getElementById('esvysendtooltip');
  var bt  = document.getElementById('but');


 if ( ttp==null || bt==null )
	return true

  if(ttp.openPopup){ //FFX3
    ttp.openPopup(bt,'after_pointer',0,15,false,false);
  }else if(ttp.showPopup){
    ttp.showPopup(bt,-1,-1,'tooltip','bottomleft','topleft');
  }
  else{
    //alert('Esto no debería pasar');
  }
}



function TTPhide(nombre){

  var ttp = document.getElementById(nombre);

  if (ttp == null)  
    return true

  if ((ttp.hidePopup && !esvyisffx2) || nombre=='esvysendtooltip'){

    ttp.hidePopup();
  }
  else{

    document.getElementById('content').contentDocument.defaultView.window.status = esvylastmsg;
  }
}









function cerrarBarra(){
  
  ////dump('--------------->Chrome: Cerrando barra\n');

  document.getElementById('esurveymenuitem').setAttribute("disabled", "false");

  //++++++
  //Pongo estte try porque hay casos en que la barra se queda abierta y el objeto enc no existe. As al menos la cerrar sin tener que cerrar la ventana.
  try{
    enc.chStage('close');
  }catch(e){
    
  }
  ////dump('--------------->QQQQQQ\n');

  var padre = document.getElementById('navigator-toolbox')

  var iter = padre.firstChild;
  while(iter!=padre.lastChild){

    if(iter.id == 'esurvey-toolbar'){ 
      padre.removeChild(iter);
      break;
    }
    iter = iter.nextSibling;
  }

  //Barra cerrada
  ////dump('--------------->Chrome: Setting state 0\n');
  esurveycomp.setState(0);
  document.getElementById('esurveymenuitem').label = eSvyStringsBundle.GetStringFromName('menu.load');
  //alert('barra cerrada');

  ////dump('Barra cerrada\n');
}



function finalizar(){  

  ////dump('--------------->Chrome: Finalizando\n');


  if(surveyBrowser.docShell){

    //Re-enable Javascript y otros
    //--------------------------

    // Evita la ejecución de los plugins necesarios en el doc asociado 
    surveyBrowser.docShell.allowPlugins = true;

    // Evita la ejecución del javascript existente en el doc asociado 
    surveyBrowser.docShell.allowJavascript = true;

    //Evita que salgan prompts de autenticacion ssl 
    surveyBrowser.docShell.allowAuth = true;
 }

}



function unload_handler () {
apagar(false);
}


function apagar(doconfirm){

//  //dump('--------------->Chrome: APAGAR: confirm?'+doconfirm+'\n');
//  //Como esta func se registra en el unload de la pgina, la vuelve a llamar aunque ya haya sido ocultada. controlarlo 
//  if ( doconfirm==true && esurveycomp.isActive() != 0){
//    res=true
//    res=confirm(eSvyStringsBundle.GetStringFromName('confirmbarclose')); //++++++++descoment
//    
//    if (res == false)
//    	return false
//  }
  ////dump('--------------->Chrome: APAGAR: CERRANDO LA BARRA\n');

  finalizar();

  //alert('hola');
  cerrarBarra();

}






